interface Callable<T> {
    (): T | undefined;
    <K>(fallback?: K): K extends T ? K : T | undefined;
}
declare type MixProperties<T> = {
    readonly [P in keyof T]-?: Mix<T[P]>;
};
declare type Mix<T> = Callable<T> & MixProperties<T> & {
    [key: string]: any;
};
export declare function safeTouch<T>(source: T): Mix<T>;
export default safeTouch;
